/// <reference types="node" />
import { PortMapItem } from "./portMapItem";
import * as net from "net";
import { AcceptHandler } from "./acceptHandler";
import { LifeCycleListener } from "./lifeCycleListener";
import { NonBlockingHandler } from "./nonBlockingHandler";
import { CommandReceiver } from "./commandReceiver";
export declare class GrandAgent {
    static readonly CMD_OK = 0;
    static readonly CMD_CLOSE = 1;
    static readonly CMD_RELOAD_CERT = 2;
    static readonly CMD_MEM_USAGE = 3;
    static readonly CMD_SHUTDOWN = 4;
    static readonly CMD_ABORT = 5;
    static readonly CMD_FORK = 6;
    static agentCount: number;
    static maxAgentId: number;
    static maxShips: number;
    static multiCore: boolean;
    private static agents;
    static listeners: LifeCycleListener[];
    agentId: number;
    nonBlockingHandler: NonBlockingHandler;
    acceptHandler: AcceptHandler;
    maxInboundShips: number;
    anchorable: boolean;
    static anchorablePortMap: PortMapItem[];
    static unanchorablePortMap: PortMapItem[];
    commandReceiver: CommandReceiver;
    aborted: boolean;
    private constructor();
    toString(): string;
    reloadCert(): void;
    printUsage(): void;
    shutdown(): void;
    abort(err?: Error, status?: number): void;
    fork(agentId: number, monitorPort: number): void;
    private clean;
    static init(agtIds: number[], anchorablePortMap: PortMapItem[], unanchorablePortMap: PortMapItem[], maxShips: number, multiCore: boolean): void;
    static get(agentId: number): GrandAgent;
    static getByIndex(idx: number): GrandAgent;
    static add(agentId: number, anchorable: boolean): void;
    static addLifecycleListener(listener: LifeCycleListener): void;
    runCommandReceiver(commCh: net.Socket): void;
}
//# sourceMappingURL=grandAgent.d.ts.map