/// <reference types="node" />
/// <reference types="node" />
import { PortMapItem } from "./portMapItem";
import * as net from "net";
export declare class GrandAgentMonitor {
    static readonly AGENT_SHUTDOWN_WAIT = 3000;
    static numAgents: number;
    static curId: number;
    static anchoredPortMap: PortMapItem[];
    static monitors: Map<number, GrandAgentMonitor>;
    static finale: boolean;
    agentId: number;
    anchorable: boolean;
    communicationChannel: net.Socket;
    constructor(agentId: number, anchorable: boolean, comChannel: net.Socket);
    toString(): string;
    onRead(buf: Buffer): void;
    reloadCert(): void;
    printUsage(): void;
    shutdown(): void;
    abort(): void;
    send(cmd: number, arg1?: number, arg2?: number, arg3?: number): void;
    close(): void;
    static init(numAgents: number, anchoredPortMap: PortMapItem[]): void;
    static add(anchorable: boolean, openSocket: boolean, callback: () => void): void;
    static printUsageAll(): void;
    static reloadCertAll(): void;
    static restartAll(): void;
    static shutdownAll(): void;
    static abortAll(): void;
    private static agentAborted;
}
//# sourceMappingURL=grandAgentMonitor.d.ts.map