/// <reference types="node" />
import { NonBlockingHandler } from "../nonBlockingHandler";
import { DataListener } from "./dataListener";
import { DataConsumeListener } from "../../util/dataConsumeListener";
import { Reusable } from "../../util/Reusable";
import { Valve } from "../../util/valve";
import { Postman } from "../../util/postman";
import { ChannelListener } from "../channelListener";
import { ChannelWrapper } from "../channelWrapper";
export declare abstract class Transporter implements ChannelListener, Reusable, Valve, Postman {
    dataListener: DataListener;
    private readonly serverMode;
    private readonly traceSSL;
    protected channel: ChannelWrapper;
    protected finale: boolean;
    protected initialized: boolean;
    protected chValid: boolean;
    protected needHandshake: boolean;
    nonBlockingHandler: NonBlockingHandler;
    tmpAddress: any[];
    readBuf: Buffer;
    writeOnly: boolean;
    protected abstract secure(): boolean;
    constructor(serverMode: boolean, traceSSL: boolean, writeOnly?: boolean);
    init(chHnd: NonBlockingHandler, ch: ChannelWrapper, lis: DataListener): void;
    toString(): string;
    reset(): void;
    post(buf: Buffer, adr: any, tag: any, listener: DataConsumeListener): void;
    openValve(): void;
    onConnect(chkCh: ChannelWrapper): number;
    onRead(ch: ChannelWrapper, buf: Buffer): number;
    onWrite(ch: ChannelWrapper, listener: DataConsumeListener): number;
    checkTimeout(chkCh: ChannelWrapper, durationSec: number): boolean;
    onError(chkCh: ChannelWrapper, e: Error): void;
    onClosed(chkCh: ChannelWrapper): void;
    getBuf(): Buffer;
    abort(): void;
    isZombie(): boolean;
    flush(): void;
    postEnd(): void;
    private checkChannel;
    private checkInitialized;
    private setValid;
}
//# sourceMappingURL=transporter.d.ts.map