import 'source-map-support/register';
import { Port } from "./docker/port";
import { City } from "./docker/city";
import { Harbor } from "./docker/harbor";
import { SignalAgent } from "./agent/signal/signalAgent";
import { Cities } from "./util/cities";
export declare class BayServer {
    static scriptName: string;
    static scriptArgs: string[];
    /** Host name */
    static myHostName: string;
    /** BSERV_HOME directory */
    static bservHome: string;
    /** Configuration file name (full path) */
    static bservPlan: string;
    /** Conf files directory */
    static bservLib: string;
    private static softwareName;
    static cities: Cities;
    /** Port dockers */
    static ports: Port[];
    /** Harbor docker */
    static harbor: Harbor;
    /** BayAgent */
    static signalAgent: SignalAgent;
    static main(args: string[]): void;
    static getHome(home: string): void;
    static getPlan(plan: string): void;
    static getLib(): void;
    static init(): void;
    static start(agentId: number, openPort: boolean, monitorPort: number): void;
    private static openPorts;
    private static parentStart;
    private static childStart;
    private static initChildGrandAgent;
    private static connectToMonitor;
    static findCity(name: string): City;
    static parsePath(location: string): string;
    static getLocation(location: string): string;
    private static loadPlan;
    /**
     * Print version information
     */
    private static printVersion;
    static getVersion(): string;
    static getSoftwareName(): string;
    private static createPidFile;
}
//# sourceMappingURL=bayserver.d.ts.map