"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BcfDocument = void 0;
const bcfElement_1 = require("./bcfElement");
class BcfDocument {
    constructor() {
        this.contentList = [];
    }
    print() {
        this.printContentList(this.contentList, 0);
    }
    printContentList(list, indent) {
        for (const o of list) {
            this.printIndent(indent);
            if (o instanceof bcfElement_1.BcfElement) {
                const elm = o;
                console.log("Element(" + elm.name + "," + elm.arg + "){\n");
                this.printContentList(elm.contentList, indent + 1);
                this.printIndent(indent);
                console.log("}\n");
            }
            else {
                const kv = o;
                this.printKeyVal(kv);
                console.log("\n");
            }
        }
    }
    printKeyVal(kv) {
        console.log("KeyVal(" + kv.key + "=" + kv.value + ")");
    }
    printIndent(indent) {
        for (let i = 0; i < indent; i++) {
            console.log(" ");
        }
    }
}
exports.BcfDocument = BcfDocument;
//# sourceMappingURL=bcfDocument.js.map