/// <reference types="node" />
import { Ship } from "../../watercraft/ship";
import { ProtocolHandler } from "../../protocol/protocolHandler";
import { GrandAgent } from "../../agent/grandAgent";
import { Port } from "../port";
import { Counter } from "../../util/counter";
import { TourStore } from "../../tour/tourStore";
import { Tour } from "../../tour/tour";
import { Postman } from "../../util/postman";
import { Buffer } from "buffer";
import { ChannelWrapper } from "../../agent/channelWrapper";
export declare class InboundShip extends Ship {
    portDocker: Port;
    static errCounter: Counter;
    needEnd: boolean;
    socketTimeoutSec: number;
    tourStore: TourStore;
    activeTours: Tour[];
    reset(): void;
    initInbound(ch: ChannelWrapper, agt: GrandAgent, pm: Postman, portDkr: Port, protoHandler: ProtocolHandler<any, any>): void;
    toString(): string;
    endShip(): void;
    abortTours(): void;
    getTour(turKey: number, force?: boolean): Tour;
    private static uniqKey;
    returnTour(tur: Tour): void;
    getErrorTour(): Tour;
    sendHeaders(chkId: number, tur: Tour): void;
    sendRedirect(chkId: number, tur: Tour, status: number, location: string): void;
    sendResContent(chkId: number, tur: Tour, buf: Buffer, ofs: number, len: number, lis: () => void): void;
    sendEndTour(chkShipId: number, chkTourId: number, tur: Tour, callback: () => void): void;
    sendError(chkId: number, tur: Tour, status: number, message: string, e: Error): void;
    private sendErrorContent;
}
//# sourceMappingURL=inboundShip.d.ts.map