"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InboundShipStore = void 0;
const objectStore_1 = require("../../util/objectStore");
const inboundShip_1 = require("./inboundShip");
const bayLog_1 = require("../../bayLog");
const strUtil_1 = require("../../util/strUtil");
const grandAgent_1 = require("../../agent/grandAgent");
class AgentListener {
    add(agentId) {
        InboundShipStore.stores[agentId] = new InboundShipStore();
    }
    remove(agentId) {
        delete InboundShipStore.stores[agentId];
    }
}
class InboundShipStore extends objectStore_1.ObjectStore {
    constructor() {
        super(() => new inboundShip_1.InboundShip());
    }
    /**
     *  print memory usage
     */
    printUsage(indent) {
        bayLog_1.BayLog.info("%sInboundShipStore Usage:", strUtil_1.StrUtil.indent(indent));
        super.printUsage(indent + 1);
    }
    static init() {
        grandAgent_1.GrandAgent.addLifecycleListener(new AgentListener());
    }
    static getStore(agentId) {
        return this.stores[agentId];
    }
}
/** Agent id => InboundShipStore */
InboundShipStore.stores = {};
exports.InboundShipStore = InboundShipStore;
//# sourceMappingURL=inboundShipStore.js.map