import { City } from "../city";
import { DockerBase } from "../base/dockerBase";
import { Club } from "../club";
import { Tour } from "../../tour/tour";
import { Trouble } from "../trouble";
import { BcfElement } from "../../bcf/bcfElement";
import { Docker } from "../docker";
import { Town } from "../town";
import { Log } from "../log";
import { Permission } from "../permission";
export declare class ClubMatchInfo {
    club: Club;
    scriptName: string;
    pathInfo: string;
}
export declare class MatchInfo {
    town: Town;
    clubMatch: ClubMatchInfo;
    queryString: string;
    redirectURI: string;
    rewrittenURI: string;
}
export declare class BuiltInCityDocker extends DockerBase implements City {
    townList: Town[];
    defaultTown: Town;
    clubList: Club[];
    defaultClub: Club;
    logList: Log[];
    permissionList: Permission[];
    trouble: Trouble;
    name: string;
    toString(): string;
    init(elm: BcfElement, parent: Docker): void;
    initDocker(dkr: Docker): boolean;
    getName(): string;
    getClubs(): Club[];
    getTowns(): Town[];
    enter(tur: Tour): void;
    getTrouble(): Trouble;
    log(tour: Tour): void;
    getType(): string;
    clubMaches(clubList: Club[], relUri: string, townName: string): ClubMatchInfo;
    /**
     * Determine club from request URI
     */
    getTownAndClub(reqUri: string): MatchInfo;
}
//# sourceMappingURL=builtInCityDocker.d.ts.map