import { DockerBase } from "../base/dockerBase";
import { Log } from "../log";
import { Tour } from "../../tour/tour";
import { LogBoat } from "./logBoat";
import { GrandAgent } from "../../agent/grandAgent";
import { LogItem } from "./logItem";
import { Docker } from "../docker";
import { BcfElement } from "../../bcf/bcfElement";
import { BcfKeyVal } from "../../bcf/bcfKeyVal";
import { LogItemFactory } from "./logItemFactory";
export declare class BuiltInLogDocker extends DockerBase implements Log {
    static readonly LOG_WRITE_METHOD_SELECT: number;
    static readonly LOG_WRITE_METHOD_SPIN: number;
    static readonly LOG_WRITE_METHOD_TAXI: number;
    static readonly DEFAULT_LOG_WRITE_METHOD: number;
    /** Mapping table for format */
    static map: Map<string, LogItemFactory>;
    /** Log file name parts */
    filePrefix: string;
    fileExt: string;
    /**
     *  Logger for each agent.
     *  Map of Agent ID => LogBoat
     */
    loggers: Map<number, LogBoat>;
    /** Log format */
    format: string;
    /** Log items */
    logItems: LogItem[];
    /** Log write method */
    logWriteMethod: number;
    static lineSep: string;
    constructor();
    init(elm: BcfElement, parent: Docker): void;
    initKeyVal(kv: BcfKeyVal): boolean;
    log(tour: Tour): void;
    /**
     * Compile format pattern
     */
    compile(str: string, items: LogItem[], fileName: string, lineNo: number): void;
    /**
     * Compile format pattern(Control code)
     */
    compileCtl(str: string, items: LogItem[], fileName: string, lineNo: number): void;
    getLogger(agt: GrandAgent): LogBoat;
    static initClass(): void;
}
//# sourceMappingURL=builtInLogDocker.d.ts.map