/// <reference types="node" />
import * as net from "net";
import { Tour } from "../../tour/tour";
import { Group } from "../../util/groups";
import { DockerBase } from "../base/dockerBase";
import { Permission } from "../permission";
import { BcfKeyVal } from "../../bcf/bcfKeyVal";
interface PermissionMatcher {
    matchSocket(ch: net.Socket): boolean;
    matchTour(tur: Tour): boolean;
}
declare class CheckItem {
    matcher: PermissionMatcher;
    admit: boolean;
    constructor(matcher: PermissionMatcher, admit: boolean);
    socketAdmitted(ch: net.Socket): boolean;
    tourAdmitted(tur: Tour): boolean;
}
export declare class BuiltInPermissionDocker extends DockerBase implements Permission {
    checkList: CheckItem[];
    groups: Group[];
    initKeyVal(kv: BcfKeyVal): boolean;
    socketAdmitted(ch: any): void;
    tourAdmitted(tour: Tour): void;
    parseValue(kv: BcfKeyVal): PermissionMatcher[];
}
export {};
//# sourceMappingURL=builtInPermissionDocker.d.ts.map