/// <reference types="node" />
import { DockerBase } from "../base/dockerBase";
import { Secure } from "../Secure";
import { Docker } from "../docker";
import { BcfElement } from "../../bcf/bcfElement";
import { BcfKeyVal } from "../../bcf/bcfKeyVal";
import { Transporter } from "../../agent/transporter/transporter";
import * as net from "net";
export declare class BuiltInSecureDocker extends DockerBase implements Secure {
    static readonly DEFAULT_CLIENT_AUTH = false;
    static readonly DEFAULT_SSL_PROTOCOL = "TLS";
    keyStore: string;
    keyStorePass: string;
    clientAuth: boolean;
    sslProtocol: string;
    keyFile: string;
    certFile: string;
    certs: string;
    certsPass: string;
    traceSSL: boolean;
    sslctx: any;
    appProtocols: string[];
    init(elm: BcfElement, parent: Docker): void;
    initKeyVal(kv: BcfKeyVal): boolean;
    setAppProtocols(protocols: string[]): void;
    createTransporter(): Transporter;
    reloadCert(): void;
    createServer(): net.Server;
    private initSSL;
    private getFilePath;
    createTlsSocket(ch: net.Socket, server: net.Server): net.Socket;
}
//# sourceMappingURL=builtInSecureDocker.d.ts.map