import { ClubBase } from "../base/clubBase";
import { Tour } from "../../tour/tour";
import { GrandAgent } from "../../agent/grandAgent";
import { Transporter } from "../../agent/transporter/transporter";
import { Docker } from "../docker";
import { BcfElement } from "../../bcf/bcfElement";
import { BcfKeyVal } from "../../bcf/bcfKeyVal";
import { WarpShip } from "./warpShip";
import { ProtocolHandler } from "../../protocol/protocolHandler";
import { WarpShipStore } from "./warpShipStore";
import { ProtocolHandlerStore } from "../../protocol/protocolHandlerStore";
import { ChannelWrapper } from "../../agent/channelWrapper";
export declare abstract class WarpDocker extends ClubBase {
    host: string;
    port: number;
    warpBase: string;
    maxShips: number;
    hostAddr: string;
    timeoutSec: number;
    tourList: Tour[];
    /** Agent ID => WarpShipStore */
    stores: Map<number, WarpShipStore>;
    abstract isSecure(): boolean;
    abstract protocol(): string;
    abstract newTransporter(agt: GrandAgent, ch: ChannelWrapper): Transporter;
    constructor();
    init(elm: BcfElement, parent: Docker): void;
    initKeyVal(kv: BcfKeyVal): boolean;
    arrive(tour: Tour): void;
    keepShip(wsip: WarpShip): void;
    returnShip(wsip: WarpShip): void;
    returnProtocolHandler(agt: GrandAgent, protoHnd: ProtocolHandler<any, any>): void;
    getShipStore(agtId: number): WarpShipStore;
    getProtocolHandlerStore(agtId: number): ProtocolHandlerStore<any, any>;
}
//# sourceMappingURL=warpDocker.d.ts.map