"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpException = void 0;
const bayException_1 = require("./bayException");
const httpStatus_1 = require("./util/httpStatus");
const util_1 = require("util");
class HttpException extends bayException_1.BayException {
    constructor(status, fmt = null, ...args) {
        if (status < 300 || status >= 600)
            throw new Error("Illegal Http error status code: " + status);
        var msg;
        if (fmt == null)
            msg = "";
        else if (args == null)
            msg = fmt;
        else
            msg = (0, util_1.format)(fmt, ...args);
        super("HTTP %d %s: %s", status, httpStatus_1.HttpStatus.description(status), msg);
        this.status = status;
    }
    static movedTemp(location) {
        let e = new HttpException(httpStatus_1.HttpStatus.MOVED_TEMPORARILY, location);
        e.location = location;
        return e;
    }
}
exports.HttpException = HttpException;
//# sourceMappingURL=httpException.js.map