/// <reference types="node" />
import { Reusable } from "../util/Reusable";
import { PacketUnpacker } from "./packetUnpacker";
import { Command } from "./command";
import { Packet } from "./packet";
import { PacketPacker } from "./packetPacker";
import { CommandUnPacker } from "./commandUnpacker";
import { CommandPacker } from "./commandPacker";
import { PacketStore } from "./packetStore";
import { Ship } from "../watercraft/ship";
export declare abstract class ProtocolHandler<C extends Command<C, P, any>, P extends Packet> implements Reusable {
    packetUnpacker: PacketUnpacker<P>;
    packetPacker: PacketPacker<P>;
    commandUnpacker: CommandUnPacker<P>;
    commandPacker: CommandPacker<C, P, any>;
    packetStore: PacketStore<P>;
    serverMode: boolean;
    ship: Ship;
    abstract protocol(): string;
    /**
     * Get max of request data size (maybe not packet size)
     */
    abstract maxReqPacketDataSize(): number;
    /**
     * Get max of response data size (maybe not packet size)
     */
    abstract maxResPacketDataSize(): number;
    toString(): string;
    reset(): void;
    bytesReceived(buf: Buffer): number;
}
//# sourceMappingURL=protocolHandler.d.ts.map