import { ObjectStore } from "../util/objectStore";
import { ProtocolHandler } from "./protocolHandler";
import { PacketStore } from "./packetStore";
import { ProtocolHandlerFactory } from "./protocolHandlerFactory";
import { Packet } from "./packet";
import { Command } from "./command";
declare class ProtocolInfo<C extends Command<C, P, any>, P extends Packet> {
    readonly protocol: string;
    readonly serverMode: boolean;
    readonly protocolHandlerFactory: ProtocolHandlerFactory<any, any>;
    /** Agent ID => ProtocolHandlerStore */
    readonly stores: Map<number, ProtocolHandlerStore<C, P>>;
    constructor(proto: string, svrMode: boolean, protocolHandlerFactory: ProtocolHandlerFactory<C, P>);
    addAgent(agtId: number): void;
    removeAgent(agtId: number): void;
}
export declare class ProtocolHandlerStore<C extends Command<C, P, any>, P extends Packet> extends ObjectStore<ProtocolHandler<C, P>> {
    static protoMap: Map<string, ProtocolInfo<any, any>>;
    protocol: string;
    serverMode: boolean;
    constructor(protocol: string, svrMode: boolean, phFactory: ProtocolHandlerFactory<C, P>, pktStore: PacketStore<P>);
    /**
     * print memory usage
     */
    printUsage(indent: number): void;
    static init(): void;
    static getStore(proto: string, svrMode: boolean, agentId: number): ProtocolHandlerStore<any, any>;
    static getStores(agentId: number): ProtocolHandlerStore<any, any>[];
    static registerProtocol(protocol: string, svrMode: boolean, pHndFactory: ProtocolHandlerFactory<any, any>): void;
    static getProtocolForm(protocol: string, svrMode: boolean): string;
    static initClass(): void;
}
export {};
//# sourceMappingURL=protocolHandlerStore.d.ts.map