/// <reference types="node" />
import { Tour } from "./tour";
import { ReqContentHandler } from "./reqContentHandler";
import { ContentConsumeListener } from "./contentConsumeListener";
import { HttpHeaders } from "../util/httpHeaders";
import { Reusable } from "../util/Reusable";
export type RemoteHostResolver = () => string;
export declare class TourReq implements Reusable {
    private readonly tour;
    /**
     * Request Header info
     */
    key: number;
    uri: string;
    protocol: string;
    method: string;
    headers: HttpHeaders;
    rewrittenURI: string;
    queryString: string;
    pathInfo: any;
    scriptName: string;
    reqHost: any;
    reqPort: number;
    remoteUser: string;
    remotePass: string;
    remoteAddress: string;
    remotePort: number;
    remoteHostFunc: RemoteHostResolver;
    serverAddress: string;
    serverPort: number;
    serverName: string;
    charset: string;
    /**
     * Request content info
     */
    bytesPosted: number;
    bytesConsumed: number;
    bytesLimit: number;
    contentHandler: ReqContentHandler;
    consumeListener: ContentConsumeListener;
    available: boolean;
    ended: boolean;
    constructor(tour: Tour);
    init(key: number): void;
    reset(): void;
    remoteHost(): string;
    setContentHandler(hnd: ReqContentHandler): void;
    setConsumeListener(limit: number, listener: ContentConsumeListener): void;
    postContent(checkId: number, data: Buffer, start: number, len: number): boolean;
    endContent(checkId: number): void;
    consumed(checkId: number, length: number): void;
    abort(): boolean;
    private bufferAvailable;
}
//# sourceMappingURL=tourReq.d.ts.map