"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StrUtil = void 0;
const charUtil_1 = require("./charUtil");
const bayLog_1 = require("../bayLog");
const buffer_1 = require("buffer");
class StrUtil {
    static eqIgnoreCase(s1, s2) {
        return s1.toLowerCase() == s2.toLowerCase();
    }
    static isSet(s) {
        return s != null && s != "";
    }
    static empty(s) {
        return !this.isSet(s);
    }
    static indent(count) {
        return " ".repeat(count);
    }
    /**
     * Maybe faster
     */
    static toLowerCase(str) {
        for (let i = 0; i < str.length; i++) {
            let c = str.charCodeAt(i);
            if (c >= charUtil_1.CharUtil.A_CODE && c <= charUtil_1.CharUtil.Z_CODE) {
                return str.toLowerCase();
            }
        }
        return str;
    }
    static parseBool(val) {
        val = val.toLowerCase();
        if (this.trues.includes(val))
            return true;
        else if (this.falses.includes(val))
            return false;
        else {
            bayLog_1.BayLog.warn("Invalid boolean value: " + val);
            return false;
        }
    }
    static parseSize(value) {
        value = value.toLowerCase();
        let rate = 1;
        if (value.endsWith("b"))
            value = value.substring(0, value.length - 1);
        if (value.endsWith("k")) {
            value = value.substring(0, value.length - 1);
            rate = 1024;
        }
        else if (value.endsWith("m")) {
            value = value.substring(0, value.length - 1);
            rate = 1024 * 1024;
        }
        return Number.parseInt(value) * rate;
    }
    static parseCharset(charset) {
        return charset;
    }
    static toEncoding(encoding) {
        switch (encoding.toLowerCase()) {
            case "iso-8859-1":
                return "ascii";
                return "utf8";
            case "utf-8":
                return "utf-8";
            case "utf-16":
                return "utf16le";
            default:
                return null;
        }
    }
    static toBytes(str) {
        return buffer_1.Buffer.from(str, "latin1");
    }
    static fromBytes(bytes, start = 0, len = bytes.length) {
        return bytes.toString("latin1", start, len);
    }
}
StrUtil.falses = ["no", "false", "0", "off"];
StrUtil.trues = ["yes", "true", "1", "on"];
exports.StrUtil = StrUtil;
//# sourceMappingURL=strUtil.js.map