"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SysUtil = void 0;
const process_1 = require("process");
const path_1 = require("path");
const fs_1 = require("fs");
const fs = require("fs");
const net = require("net");
const path = require("path");
class SysUtil {
    static isAbsolutePath(pathStr) {
        return path.isAbsolute(pathStr);
    }
    static getAbsolutePath(path) {
        if (SysUtil.isAbsolutePath(path))
            return path;
        return (0, path_1.join)((0, process_1.cwd)(), path);
    }
    static isFile(path) {
        try {
            let s = (0, fs_1.statSync)(path);
            return s.isFile();
        }
        catch (e) {
            return false;
        }
    }
    static isDirectory(path) {
        try {
            let s = (0, fs_1.statSync)(path);
            return s.isDirectory();
        }
        catch (e) {
            return false;
        }
    }
    static joinPath(path1, path2) {
        return (0, path_1.join)(path1, path2);
    }
    static exists(path) {
        return fs.existsSync(path);
    }
    static getFileSize(path) {
        let stat = fs.statSync(path);
        if (stat == null)
            throw new Error("File not found: " + path);
        return stat.size;
    }
    static runOnWindows() {
        return process.platform == 'win32';
    }
    static pid() {
        return process.pid;
    }
    static supportUnixDomainSocketAddress() {
        return !SysUtil.runOnWindows();
    }
    static openUnixDomainSocketChannel(sktPath) {
        return net.createConnection(sktPath);
    }
    static copyDir(srcDir, dstDir) {
        const files = fs.readdirSync(srcDir);
        if (!fs.existsSync(dstDir)) {
            fs.mkdirSync(dstDir);
        }
        files.forEach(file => {
            const srcFile = path.join(srcDir, file);
            const dstFile = path.join(dstDir, file);
            const stats = fs.statSync(srcFile);
            if (stats.isFile()) {
                fs.copyFileSync(srcFile, dstFile);
            }
            else if (stats.isDirectory()) {
                this.copyDir(srcFile, dstFile);
            }
        });
    }
}
exports.SysUtil = SysUtil;
//# sourceMappingURL=sysUtil.js.map