import { Reusable } from "../util/Reusable";
import { Postman } from "../util/postman";
import { GrandAgent } from "../agent/grandAgent";
import { ProtocolHandler } from "../protocol/protocolHandler";
import { Counter } from "../util/counter";
import { ChannelWrapper } from "../agent/channelWrapper";
export declare abstract class Ship implements Reusable {
    static readonly SHIP_ID_NOCHECK: number;
    static readonly INVALID_SHIP_ID: number;
    static readonly oidCounter: Counter;
    static readonly idCounter: Counter;
    readonly objectId: number;
    shipId: number;
    agent: GrandAgent;
    postman: Postman;
    ch: ChannelWrapper;
    protocolHandler: ProtocolHandler<any, any>;
    initialized: boolean;
    keeping: boolean;
    constructor();
    init(ch: ChannelWrapper, agent: GrandAgent, pm: Postman): void;
    reset(): void;
    setProtocolHandler(protoHandler: ProtocolHandler<any, any>): void;
    id(): number;
    protocol(): string;
    resume(checkId: number): void;
    checkShipId(shipId: number): void;
}
//# sourceMappingURL=ship.d.ts.map