/// <reference types="node" />
import { Counter } from "../util/counter";
import { DataListener } from "../agent/transporter/dataListener";
import { Reusable } from "../util/Reusable";
import { ProtocolException } from "../protocol/protocolException";
export declare abstract class Yacht implements DataListener, Reusable {
    static readonly INVALID_YACHT_ID: number;
    static oidCounter: Counter;
    static idCounter: Counter;
    readonly objectId: number;
    yachtId: number;
    constructor();
    initYacht(): void;
    notifyConnect(): number;
    notifyHandshakeDone(protocol: string): number;
    notifyProtocolError(e: ProtocolException): boolean;
    abstract checkTimeout(durationSec: number): boolean;
    abstract notifyClose(): any;
    abstract notifyEof(): number;
    abstract notifyError(err: Error): void;
    abstract notifyRead(buf: Buffer, adr: any): number;
    abstract reset(): any;
}
//# sourceMappingURL=yacht.d.ts.map